#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <shlwapi.h>

DLL_DIRECTORY_COOKIE dircookie = nullptr;
DWORD instances = 0;

BOOL APIENTRY DllMain(HMODULE hmodule, DWORD dwreason, LPVOID lpreserved)
{
	TCHAR path[MAX_PATH];
	path[0] = 0;

	switch (dwreason)
	{
	case DLL_PROCESS_ATTACH:
		if ((instances++) == 0 && !dircookie)
		{
			SetDefaultDllDirectories(LOAD_LIBRARY_SEARCH_DEFAULT_DIRS);
			GetModuleFileName(hmodule, path, MAX_PATH);
			PathRemoveFileSpec(path);
			dircookie = AddDllDirectory(path);
		}

	break;

	case DLL_PROCESS_DETACH:

		if ((--instances) == 0 && dircookie)
		{
			RemoveDllDirectory(dircookie);
			dircookie = nullptr;
		}

	break;
	}
	return TRUE;
}
